{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
{$M 2048,0,655360}

uses
  Fossil, Hex, DelaySnd;

var
  Port: TFossilPort;
  Ofs, Seg: Word;
  Ptr: Pointer absolute Ofs;
  S: String;
  Buf: Array [0..$FF] of Byte;
  BufPos, BufCnt,
  Error1, Error2: Integer;
  f: File;

procedure SendAT(const Cmd: String);
begin
  Port.SendString('AT'+Cmd+#13);
  while Port.ReceiveChar<>#10 do;
  while not Port.CharAvail do;
end;

procedure Wait;
var
  Count: Integer;
begin
  for Count:=0 to 199 do
  begin
    if Port.CharAvail then Break;
    Delay(1);
  end;
end;

begin
  WriteLn(#13#10'USR Courier Flash ROM Ripper  Copyright (c) 1996 by Solar Designer'#13#10);

  InitDelay;

  Port.Init(1);
  if not Port.Initialized then
  begin
    WriteLn('Unable to initialize FOSSIL'); Halt;
  end;

  SendAT('&F1');
  if (Port.ReceiveChar='O') and (Port.ReceiveChar='K') then
  begin
    while Port.ReceiveChar<>#10 do;

    Assign(f, 'USRFLASH.RAW');
    Rewrite(f, 1);

    Seg:=$8000;
    repeat
      Ofs:=0;
      repeat
        Write(#13, HexPointer(Ptr));
        SendAT('G='+HexPointer(Ptr));

        S:=''; BufPos:=0; Error1:=0; Error2:=0;
        repeat
          while Port.CharAvail do
          begin
            S:=S+Port.ReceiveChar;
            if S[Length(S)]=#10 then
            begin
              if (S<>'OK'#13#10) and (S<>'ERROR'#13#10) then
              if Length(S)=65 then
              begin
                if Copy(S, 1, 15)<>'  '+HexPointer(System.Ptr(Seg, Ofs+BufPos))+'    ' then Error1:=-1;
                Delete(S, 1, 12);
                BufCnt:=BufPos+15;
                repeat
                  Delete(S, 1, 3);
                  Val('$'+Copy(S, 1, 2), Buf[BufPos], Error2);
                  Error1:=Error1 or Error2;
                  if Copy(S, 1, 3)<>HexByte(Buf[BufPos])+' ' then Error1:=-1;
                  Inc(BufPos);
                until BufPos>BufCnt;
              end else Error1:=-1;
              S:='';
            end;
          end;
          if BufPos=256 then Break;
          Wait;
        until not Port.CharAvail;

        if (Error1=0) and (BufPos=256) then
        begin
          BlockWrite(f, Buf, SizeOf(Buf));
          if Ofs<>$FF00 then Inc(Ofs, $100) else Ofs:=$FFFF;
        end;
      until Ofs=$FFFF;
      Inc(Seg, $1000);
    until Seg=0;
  end else WriteLn('Unable to initialize modem');

  Close(f);

  Port.Done;
end.


